#include <xc.h>
#include "My_xlcd.h"
/*------------------------------------------------------------------------*/


// CONFIG1H
#pragma config OSC = HS         // Oscillator Selection bits (HS oscillator)
#pragma config OSCS = OFF       // Oscillator System Clock Switch Enable bit (Oscillator system clock switch option is disabled (main oscillator is source))

// CONFIG2L
#pragma config PWRT = OFF       // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOR = OFF        // Brown-out Reset Enable bit (Brown-out Reset disabled)
#pragma config BORV = 20        // Brown-out Reset Voltage bits (VBOR set to 2.0V)

// CONFIG2H
#pragma config WDT = OFF        // Watchdog Timer Enable bit (WDT disabled (control is placed on the SWDTEN bit))
#pragma config WDTPS = 128      // Watchdog Timer Postscale Select bits (1:128)

// CONFIG3H
#pragma config CCP2MUX = ON     // CCP2 Mux bit (CCP2 input/output is multiplexed with RC1)

// CONFIG4L
#pragma config STVR = ON        // Stack Full/Underflow Reset Enable bit (Stack Full/Underflow will cause RESET)
#pragma config LVP = ON         // Low Voltage ICSP Enable bit (Low Voltage ICSP enabled)

// CONFIG5L
#pragma config CP0 = OFF        // Code Protection bit (Block 0 (000200-001FFFh) not code protected)
#pragma config CP1 = OFF        // Code Protection bit (Block 1 (002000-003FFFh) not code protected)
#pragma config CP2 = OFF        // Code Protection bit (Block 2 (004000-005FFFh) not code protected)
#pragma config CP3 = OFF        // Code Protection bit (Block 3 (006000-007FFFh) not code protected)

// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot Block (000000-0001FFh) not code protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM not code protected)

// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (000200-001FFFh) not write protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (002000-003FFFh) not write protected)
#pragma config WRT2 = OFF       // Write Protection bit (Block 2 (004000-005FFFh) not write protected)
#pragma config WRT3 = OFF       // Write Protection bit (Block 3 (006000-007FFFh) not write protected)

// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) not write protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot Block (000000-0001FFh) not write protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM not write protected)

// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (000200-001FFFh) not protected from Table Reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (002000-003FFFh) not protected from Table Reads executed in other blocks)
#pragma config EBTR2 = OFF      // Table Read Protection bit (Block 2 (004000-005FFFh) not protected from Table Reads executed in other blocks)
#pragma config EBTR3 = OFF      // Table Read Protection bit (Block 3 (006000-007FFFh) not protected from Table Reads executed in other blocks)

// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot Block (000000-0001FFh) not protected from Table Reads executed in other blocks)



 
 
/*------------------------------------------------------------------------*/
 
#define _XTAL_FREQ (8000000)    /* Not using xtal, only to make delays work as
                                    it won't compile without this */
 
 
void DelayFor18TCY(void);
void DelayPORXLCD(void);
void DelayXLCD(void);
 
/*------------------------------------------------------------------------*/
 
void main (void)
{
    OSCCON = 0b01100010;            // Fosc = 4MHz (Inst. clk = 1MHz)
    ADCON1 = 0xF;                   // No analog, all digital i/o
    TRISA = 0x00;
    TRISB = 0x0;
    TRISC = 0x0;
    LATB = 0x0;
 
 
while(1)
{
 
    OpenXLCD(FOUR_BIT & LINES_5X7 & CURSOR_ON & BLINK_ON);
    while(BusyXLCD());
 
    WriteCmdXLCD(SHIFT_DISP_LEFT);
    while(BusyXLCD());
 
    WriteDataXLCD('A');
    while(BusyXLCD());
 
    WriteDataXLCD('t');
    while(BusyXLCD());
 
    WriteDataXLCD(' ');
    while(BusyXLCD());
 
    putrsXLCD( "last! XLCD," );
    while(BusyXLCD());
 
    WriteCmdXLCD(0xC0);
    while(BusyXLCD());
 
    putrsXLCD( "thanks Ian" );
    while(BusyXLCD());
 
    while(1);
 
    }
 
 }
/*------------------------------------------------------------------------*/
void DelayFor18TCY(void)
{
    __delay_us(18);
 
    }
 
/*------------------------------------------------------------------------*/
void DelayPORXLCD(void)
{
     __delay_ms(15);
 
    }
/*------------------------------------------------------------------------*/
void DelayXLCD(void)
{
    __delay_ms(5);
 
    }
/*------------------------------------------------------------------------*/